/*Configuracion:
  ATtiny Pin 1 = IPMC4
  ATtiny Pin 2 = IPMC3
  ATtiny Pin 3 = IPMC1
  ATtiny Pin 4 = GND
  ATtiny Pin 5 = I2C SDA
  ATtiny Pin 6 = IPMC2
  ATtiny Pin 7 = I2C SCK
  ATtiny Pin 8 = VCC 3.3V*/

#include "TinyWireS.h"
#include "usiTwiSlave.h"
volatile byte msg = 0;
#define I2C_SLAVE_ADDR  0x29
// direccion del esclavo i2c (38)
#define IPMC1_PIN         4
// ATtiny Pin 3
#define IPMC2_PIN         1
// ATtiny Pin 6
#define IPMC3_PIN         3
//ATtiny Pin  2
#define IPMC4_PIN         5
//Attiny Pin 1


void setup() {
  pinMode(IPMC1_PIN, OUTPUT);
  pinMode(IPMC2_PIN, OUTPUT);
  pinMode(IPMC3_PIN, OUTPUT);
  pinMode(IPMC4_PIN, OUTPUT);
  byte mensaje = 0;
  TinyWireS.begin(I2C_SLAVE_ADDR);
  // Inicializa el esclavo

}

void loop() {
  byte mensaje = 0;
  if (TinyWireS.available()) {
    // Permanece a la escucha. Si se le envia algo a este esclavo
    mensaje = TinyWireS.receive();
    // recibe y almacena la informacion del maestro
    Turn_on(mensaje);
    // Completa el pedido. El maestro debe esperar a que se complete para pedir informacion
    mensaje += 10;
    // Se añade F0 al mensaje recibido
    TinyWireS.send(mensaje);
    // Se envia de vuelta al maestro
  }
}

void Turn_on(byte data) {
  //Accionado del actuador
  byte mascara = B1;
  //La mascara determina que bit se esta leyendo
  if (mascara & data) {
    //Si el bit es HIGH se activa el actuador. En caso contrario se desactiva
    digitalWrite (IPMC1_PIN, HIGH);
  }
  else {
    digitalWrite (IPMC1_PIN, LOW);
  }

  mascara = B10;
  if (mascara & data) {
    digitalWrite (IPMC2_PIN, HIGH);
  }
  else {
    digitalWrite (IPMC2_PIN, LOW);
  }

  mascara = B100;
  if (mascara & data) {
    digitalWrite (IPMC3_PIN, HIGH);
  }
  else {
    digitalWrite (IPMC3_PIN, LOW);
  }

  mascara = B1000;
  if (mascara & data) {
    digitalWrite (IPMC4_PIN, HIGH);
  }
  else {
    digitalWrite (IPMC4_PIN, LOW);
  }
}




